import React from "react";
import { GoogleViz, GoogleChartWrapperChartType, ChartWrapperOptions, GoogleChartWrapper, GoogleDataTableRow, GoogleDataTableColumn, GoogleVizEventName, GoogleChartAction } from "./types";
export declare type WindowWithMaybeGoogle = Window & {
    google?: any;
};
export declare type ReactGoogleChartProps = {
    height: string | number;
    width: string | number;
    graphID: string;
    chartType: GoogleChartWrapperChartType;
    options: Partial<ChartWrapperOptions["options"]>;
    loader: JSX.Element;
    data: any[];
    rows: GoogleDataTableRow[];
    columns: GoogleDataTableColumn[];
    chartActions: GoogleChartAction[];
    events: {
        eventName: GoogleVizEventName;
        callback: (chartWrapper: GoogleChartWrapper) => void;
    }[];
};
export declare type ReactGoogleChartState = {
    loadingStatus: "loading" | "errored" | "ready";
    google: null | GoogleViz;
};
export declare const chartDefaultProps: {
    graphID: string;
    options: {};
    rows: null;
    columns: null;
    data: null;
    events: null;
    legendToggle: boolean;
};
declare class Chart extends React.Component<ReactGoogleChartProps & typeof chartDefaultProps, ReactGoogleChartState> {
    state: ReactGoogleChartState;
    chartWrapper: GoogleChartWrapper | null;
    hidden_columns: {};
    componentWillUnmount(): void;
    static defaultProps: {
        graphID: string;
        options: {};
        rows: null;
        columns: null;
        data: null;
        events: null;
        legendToggle: boolean;
    };
    private draw;
    componentDidMount(): void;
    setChartActions: (currentActions: GoogleChartAction[], previousActions: GoogleChartAction[]) => void;
    listenToChartEvents: () => void;
    componentDidUpdate(prevProps: ReactGoogleChartProps, prevState: ReactGoogleChartState): void;
    private handleGoogleChartsLoaderScriptLoaded;
    private handleGoogleChartsLoaderScriptErrored;
    render(): JSX.Element;
}
export { Chart };
export default Chart;
